searchNodes=[{"ref":"Fluent.html","title":"Fluent","type":"module","doc":"Module"},{"ref":"Fluent.html#get_locale/1","title":"Fluent.get_locale/1","type":"function","doc":"Gets the locale for the current process and the given assembly. This function returns the value of the locale for the current process and the given assembly. If there is no locale for the current process and the given assembly, then either the global Fluent locale (if set), or the default locale for the given assembly, or the global default locale is returned. See the &quot;Locale&quot; section in the module documentation for more information. Examples Fluent.get_locale(MyApp.Fluent) #=&gt; &quot;en&quot;"},{"ref":"Fluent.html#known_locales/1","title":"Fluent.known_locales/1","type":"function","doc":"Returns all the locales for which FTL files exist for the given assembly. If the translations directory for the given assembly doesn&#39;t exist, then an empty list is returned. Examples With the following assembly: defmodule MyApp.Fluent do use Fluent.Assembly, otp_app: :my_app end and the following translations directory: my_app/priv/fluent ├─ en ├─ it └─ pt_BR then: Fluent.known_locales(MyApp.Fluent) #=&gt; [&quot;en&quot;, &quot;it&quot;, &quot;pt_BR&quot;]"},{"ref":"Fluent.html#put_locale/1","title":"Fluent.put_locale/1","type":"function","doc":""},{"ref":"Fluent.html#put_locale/2","title":"Fluent.put_locale/2","type":"function","doc":"Sets the locale for the current process and the given assembly. The locale is stored in the process dictionary. locale must be a string; if it&#39;s not, an ArgumentError exception is raised. Examples Fluent.put_locale(MyApp.Fluent, &quot;pt_BR&quot;) #=&gt; nil Fluent.get_locale(MyApp.Fluent) #=&gt; &quot;pt_BR&quot;"},{"ref":"Fluent.html#with_locale/2","title":"Fluent.with_locale/2","type":"function","doc":"Runs fun with the global Fluent locale set to locale. This function just sets the global Fluent locale to locale before running fun and sets it back to its previous value afterwards. Note that put_locale/2 is used to set the locale, which is thus set only for the current process (keep this in mind if you plan on spawning processes inside fun). The value returned by this function is the return value of fun. Examples Fluent.put_locale(&quot;fr&quot;) MyApp.Fluent.ftl(&quot;Hello world&quot;) #=&gt; &quot;Bonjour monde&quot; Fluent.Assembly.with_locale &quot;it&quot;, fn -&gt; MyApp.Fluent.ftl(&quot;Hello world&quot;) end #=&gt; &quot;Ciao mondo&quot; MyApp.Fluent.ftl(&quot;Hello world&quot;) #=&gt; &quot;Bonjour monde&quot;"},{"ref":"Fluent.html#with_locale/3","title":"Fluent.with_locale/3","type":"function","doc":"Runs fun with the Fluent.Assembly locale set to locale for the given assembly. This function just sets the Fluent.Assembly locale for assembly to locale before running fun and sets it back to its previous value afterwards. Note that put_locale/2 is used to set the locale, which is thus set only for the current process (keep this in mind if you plan on spawning processes inside fun). The value returned by this function is the return value of fun. Examples Fluent.put_locale(MyApp.Fluent, &quot;fr&quot;) MyApp.Fluent.ftl(&quot;Hello world&quot;) #=&gt; &quot;Bonjour monde&quot; Fluent.with_locale MyApp.Fluent, &quot;it&quot;, fn -&gt; MyApp.Fluent.ftl(&quot;Hello world&quot;) end #=&gt; &quot;Ciao mondo&quot; MyApp.Fluent.ftl(&quot;Hello world&quot;) #=&gt; &quot;Bonjour monde&quot;"},{"ref":"Fluent.html#t:assembly/0","title":"Fluent.assembly/0","type":"type","doc":"Name for Fluent&#39;s assembly. Should be valid module, that usesFluent.Assembly"},{"ref":"Fluent.html#t:bundle/0","title":"Fluent.bundle/0","type":"type","doc":"Native container, that is firstly identified and then used for translations"},{"ref":"Fluent.html#t:locale/0","title":"Fluent.locale/0","type":"type","doc":"Represents locale. Basically it&#39;s a string, that has valid locale identifier"},{"ref":"Fluent.Assembly.html","title":"Fluent.Assembly","type":"module","doc":"Module"},{"ref":"Fluent.Assembly.html#__using__/1","title":"Fluent.Assembly.__using__/1","type":"macro","doc":"Doc for using macro opts: otp_app: &quot;libfluen&quot; priv: &quot;priv/fluent&quot; default_locale: &quot;en-US&quot;"},{"ref":"Fluent.Assembly.html#t:t/0","title":"Fluent.Assembly.t/0","type":"type","doc":""},{"ref":"Fluent.Assembly.Source.html","title":"Fluent.Assembly.Source","type":"module","doc":"Module"},{"ref":"Fluent.Assembly.Source.html#assembly_dir/1","title":"Fluent.Assembly.Source.assembly_dir/1","type":"function","doc":"Returns absolute path to directory, which contains all FTL data for assembly. Examples: iex&gt; assembly_dir(MyApp.Fluent) &quot;/path/to/ftl/files/&quot;"},{"ref":"Fluent.Assembly.Source.html#ftl_files_pathes/2","title":"Fluent.Assembly.Source.ftl_files_pathes/2","type":"function","doc":"Returns absolute pathes to all FTL files for given assembly and it&#39;s locale. Examples: iex&gt; ftl_files_pathes(MyApp.Fluent, &quot;en&quot;) [&quot;/path/to/ftl/1.ftl&quot;, &quot;/path/to/ftl/2.frl&quot;, ... &quot;/path/to/ftl/last.ftl&quot;]"},{"ref":"Fluent.Assembly.Source.html#locale_dir/2","title":"Fluent.Assembly.Source.locale_dir/2","type":"function","doc":"Returns absolute path to directory, which contains all FTL data for assembly with given locale. Examples: iex&gt; assembly_dir(MyApp.Fluent, &quot;en-US&quot;) &quot;/path/to/ftl/files/en-US&quot;"},{"ref":"Fluent.Assembly.Source.html#locales/1","title":"Fluent.Assembly.Source.locales/1","type":"function","doc":"Returns list of all available locales for given assembly Examples: iex&gt; locales(MyApp.Fluent) [&quot;en&quot;, &quot;fr&quot;, &quot;ru&quot;]"},{"ref":"Fluent.MessageNotFound.html","title":"Fluent.MessageNotFound","type":"exception","doc":""},{"ref":"Fluent.Native.html","title":"Fluent.Native","type":"module","doc":"Module"},{"ref":"Fluent.Native.html#assert_locale/1","title":"Fluent.Native.assert_locale/1","type":"function","doc":""},{"ref":"Fluent.Native.html#format_pattern/3","title":"Fluent.Native.format_pattern/3","type":"function","doc":""},{"ref":"Fluent.Native.html#init/1","title":"Fluent.Native.init/1","type":"function","doc":"Initializes Fluent native bundle for given locale, and returns reference to it on succeded initialization. Examples: iex&gt; init(&quot;en&quot;) {:ok, #Reference&lt;...&gt;}"},{"ref":"Fluent.Native.html#with_resource/2","title":"Fluent.Native.with_resource/2","type":"function","doc":"Adds new FTL resource for existing bundle. Resource mast be valid FTL source. The function can returns :ok if resource is valid, and does not return bundle reference again, becuse data under the reference is mutable. Examples: iex&gt; {:ok, bundle} = init(&quot;en&quot;) {:ok, #Reference&lt;...&gt;} iex&gt; with_resource(bundle, &quot;key = Translation&quot;) :ok"},{"ref":"Fluent.Store.html","title":"Fluent.Store","type":"module","doc":"This module hande references to active bundles, that are using during runtimne of the program"},{"ref":"Fluent.Store.html#format_pattern/4","title":"Fluent.Store.format_pattern/4","type":"function","doc":""},{"ref":"Fluent.Store.html#get_store/1","title":"Fluent.Store.get_store/1","type":"function","doc":""},{"ref":"Fluent.Store.html#initialize_locale/2","title":"Fluent.Store.initialize_locale/2","type":"function","doc":"Example: iex&gt; Fluent.Store.initialize_bundle(MyApp.Fluent, &quot;en-US&quot;)"},{"ref":"Fluent.Store.html#initialize_store/1","title":"Fluent.Store.initialize_store/1","type":"function","doc":""},{"ref":"Fluent.Store.html#known_locales/1","title":"Fluent.Store.known_locales/1","type":"function","doc":""},{"ref":"Fluent.Store.html#t:t/0","title":"Fluent.Store.t/0","type":"type","doc":""},{"ref":"Test.Assembly.html","title":"Test.Assembly","type":"module","doc":"Module"},{"ref":"Test.Assembly.html#ftl/2","title":"Test.Assembly.ftl/2","type":"function","doc":""},{"ref":"readme.html","title":"libfluent","type":"extras","doc":"libfluent Module provides Project Fluent bindings and API to build internationalized applications. API is trying to be as simmilar as possible to Elixir&#39;s default internatrionalization library - Gettext At the same time, Fluent.Native module - as native binding - can be used to work with Project Fluent from any structure of choice. One can use it to define his own API, that is opposite to Gettext API as much as he wants."},{"ref":"readme.html#using-fluent","title":"libfluent - Using Fluent","type":"extras","doc":"To use Fluent, a module that calls use Fluent.Assembly has to be defined: defmodule MyApp.Fluent do use Fluent.Assembly, otp_app: :my_app end This automatically defines some funcitons in the MyApp.Fluent module, that can be used to translation: import MyApp.Fluent # Simple translation ftl(&quot;hello-world&quot;) # Argument-based translation ftl(&quot;hello-user&quot;, userName: &quot;Alice&quot;) # With different types ftl(&quot;shared-photos&quot;, userName: &quot;Alice&quot;, userGender: &quot;female&quot;, photoCount: 3)"},{"ref":"readme.html#translations","title":"libfluent - Translations","type":"extras","doc":"Translations are stored inside FTL files, with .ftl extension. Syntax overview can be found here FTL files, containgin translations for an application must be stored in a directory (by default it&#39;s priv/fluent), that has the following structure: %FLUENT_TRANSLATIONS_DIRECTORY% └─ %LOCALE% ├─ file_1.ftl ├─ file_2.ftl └─ file_3.ftl Here, %LOCALE% is the locale of the translations (for example, en_US), and file_i.ftl are FTL files containing translations. All the files from single translation are loaded as the single scope, so name conflicts inside the files in one folder should be avoided. A concrete example of such a directory structure could look like this: priv/gettext └─ en_US | ├─ default.ftl | └─ errors.ftl └─ it ├─ default.ftl └─ errors.ftl By default, Fluent expects translations to be stored under the fluent directory inside priv directory of an application. This behaviour can be changed by specifying a :priv option when using Fluent.Assembly: # Look for translations in my_app/priv/translations instead of # my_app/priv/gettext use Fluent.Assembly, otp_app: :my_app, priv: &quot;translations&quot;"},{"ref":"readme.html#locale","title":"libfluent - Locale","type":"extras","doc":"At runtime, all translation functions that do not explicitly take a locale as an argument read the locale from the assembly locale and then fallbacks to libfluent&#39;s locale. Fluent.put_locale/1 can be used to change the locale of all assemblies for the current Elixir process. That&#39;s the preferred mechanism for setting the locale at runtime. Fluent.put_locale/2 can be used when you want to set the locale of one specific Fluent assembly without affecting other Fluent assemblies. Similarly, Fluent.get_locale/0 gets the locale for all assemblies in the current process. Gettext.get_locale/1 gets the locale of a specific assembly for the current process. Check their documentation for more information. Locales are expressed as strings (like &quot;en&quot; or &quot;fr&quot;); they can be arbitrary strings as long as they match a directory name. As mentioned above, the locale is stored per-process (in the process dictionary): this means that the locale must be set in every new process in order to have the right locale available for that process. Pay attention to this behaviour, since not setting the locale will not result in any errors when Fluent.get_locale/0 or Fluent.get_locale/1 are called; the default locale will be returned instead. To decide which locale to use, each gettext-related function in a given assembly follows these steps: if there is a assembly-specific locale for the given assembly for this process (see Fluent.put_locale/2), use that, otherwise if there is a global locale for this process (see Fluent.put_locale/1), use that, otherwise if there is a assembly&#39;s specific default locale in the configuration for that assembly&#39;s :otp_app (see the Default locale section below), use that, otherwise use the default global Fluent locale (see the Default locale section below) Default locale The global Fluent default locale can be configured through the :default_locale key of the :libfluent application: config :libfluent, :default_locale, &quot;fr&quot; By default the global locale is &quot;en&quot;. If for some reason an assembly requires with a different :default_locale than all other assemblies, you can set the :default_locale inside the assembly configuration, but this approach is generally discouraged as it makes it hard to track which locale each assembly is using: config :my_app, MyApp.Fluent, default_locale: &quot;fr&quot;"},{"ref":"readme.html#installation","title":"libfluent - Installation","type":"extras","doc":"If available in Hex, the package can be installed by adding fluent to your list of dependencies in mix.exs: def deps do [ {:libfluent, &quot;~&gt; 0.1.0&quot;} ] end Documentation can be generated with ExDoc and published on HexDocs. Once published, the docs can be found at https://hexdocs.pm/libfluent."}]